ProyectoIdentity/Controllers/AutorizacionController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace ProyectoIdentity.Controllers
{
    public class AutorizacionController : Controller
    {
        // Acceso libre/publico para el usuario:
        [AllowAnonymous]
        public IActionResult AccesoPublico()
        {
            return View();
        }

        // Solo debe estar autenticado:
        [Authorize]
        public IActionResult AccesoAutenticado()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Usuario"
        //[Authorize(Roles = "Usuario")]
        [Authorize(Policy = "Usuario")]
        public IActionResult AccesoUsuario()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Registrado"
        //[Authorize(Roles = "Registrado")]
        [Authorize(Policy = "Registrado")]
        public IActionResult AccesoRegistrado()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Administrador"
        //[Authorize(Roles = "Administrador")] // opcion 1 con roles
        [Authorize(Policy = "Administrador")] // opcion 2 con policy o directivas
        public IActionResult AccesoAdministrador()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Usuario" o "Administrador"
        [Authorize(Roles = "Usuario, Administrador")]
        public IActionResult AccesoUsuarioAdministrador()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Usuario" y "Administrador"
        [Authorize(Policy = "UsuarioYAdministrador")]
        public IActionResult AccesoUsuarioYAdministrador()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Administrador" y tiene permiso para crear
        [Authorize(Policy = "AdministradorCrear")]
        public IActionResult AccesoAdministradorPermisoCrear()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Administrador" y tiene permiso para editar y borrar
        [Authorize(Policy = "AdministradorEditarBorrar")]
        public IActionResult AccesoAdministradorPermisoEditarBorrar()
        {
            return View();
        }

        // Acceso autenticado y que pertenezca al rol "Administrador" y tiene permiso para crear, editar y borrar
        [Authorize(Policy = "AdministradorCrearEditarBorrar")]
        public IActionResult AccesoAdministradorPermisoCrearEditarBorrar()
        {
            return View();
        }
    }
}

ProyectoIdentity/Controllers/RolesController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using ProyectoIdentity.Datos;

namespace ProyectoIdentity.Controllers
{
    [Authorize(Roles = "Administrador")]
    public class RolesController : Controller
    {
        private readonly UserManager<IdentityUser> _userManager;
        private readonly RoleManager<IdentityRole> _roleManager;
        private readonly ApplicationDbContext _context;

        public RolesController(
            UserManager<IdentityUser> userManager,
            RoleManager<IdentityRole> roleManager,
            ApplicationDbContext context)
        {
            _userManager = userManager;
            _roleManager = roleManager;
            _context = context;
        }

        [HttpGet]
        public IActionResult Index()
        {
            var roles = _context.Roles.ToList();

            return View(roles);
        }

        [HttpGet]
        public IActionResult Crear()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Crear(IdentityRole rol)
        {
            if (await _roleManager.RoleExistsAsync(rol.Name))
            {
                TempData["Error"] = "El nombre de rol ya existe";
                return RedirectToAction(nameof(Index));
            }

            // Se crea el rol:
            await _roleManager.CreateAsync(new IdentityRole() { Name = rol.Name });
            TempData["Correcto"] = "Rol creado correctamente";

            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        public IActionResult Editar(string id)
        {
            if (String.IsNullOrEmpty(id))
            {
                return View();
            }
            else
            {
                // Actualizar el rol:
                var rolDb = _context.Roles.FirstOrDefault(r => r.Id.Equals(id));
                return View(rolDb);
            }
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Editar(IdentityRole rol)
        {
            if (await _roleManager.RoleExistsAsync(rol.Name))
            {
                TempData["Error"] = "El nombre de rol ya existe";
                return RedirectToAction(nameof(Index));
            }

            var rolDb = _context.Roles.FirstOrDefault(r => r.Id.Equals(rol.Id));
            if (rolDb is null)
            {
                return RedirectToAction(nameof(Index));
            }

            rolDb.Name = rol.Name;
            rolDb.NormalizedName = rol.Name.ToUpper();

            var resultado = await _roleManager.UpdateAsync(rolDb);
            TempData["Correcto"] = "Rol editado correctamente";

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Borrar(string id)
        {
            var rolDb = _context.Roles.FirstOrDefault(r => r.Id.Equals(id));
            if (rolDb is null)
            {
                TempData["Error"] = "No existe el rol seleccionado";
                return RedirectToAction(nameof(Index));
            }

            var usuariosParaEsteRol = _context.UserRoles.Where(u => u.RoleId == id).Count();
            if (usuariosParaEsteRol > 0)
            {
                TempData["Error"] = "El rol tiene usuarios asignados, no se puede borrar";
                return RedirectToAction(nameof(Index));
            }

            await _roleManager.DeleteAsync(rolDb);
            TempData["Correcto"] = "Rol borrado correctamente";

            return RedirectToAction(nameof(Index));
        }

    }
}

ProyectoIdentity/Controllers/UsuariosController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using ProyectoIdentity.Claims;
using ProyectoIdentity.Datos;
using ProyectoIdentity.Models;
using System.Security.Claims;
using static ProyectoIdentity.Models.ClaimsUsuarioViewModel;

namespace ProyectoIdentity.Controllers
{
    [Authorize]
    public class UsuariosController : Controller
    {
        private readonly UserManager<IdentityUser> _userManager;
        private readonly ApplicationDbContext _context;

        public UsuariosController(
            UserManager<IdentityUser> userManager, 
            ApplicationDbContext context)
        {
            _userManager = userManager;
            _context = context;
        }

        [Authorize(Roles = "Administrador")]
        [HttpGet]
        public async Task<IActionResult> Index()
        {
            var usuarios = await _context.UserApp.ToListAsync();
            var rolesUsuario = await _context.UserRoles.ToListAsync();
            var roles = await _context.Roles.ToListAsync();

            foreach (var usuario in usuarios)
            {
                var rol = rolesUsuario.FirstOrDefault(u => u.UserId == usuario.Id);
                if (rol is null)
                {
                    usuario.Rol = "Ninguno";
                }
                else
                {
                    usuario.Rol = roles.FirstOrDefault(u => u.Id == rol.RoleId)!.Name;
                }
            }

            return View(usuarios);
        }

        // Editar usuario (asignacion de rol):
        [Authorize(Roles = "Administrador")]
        [HttpGet]
        public IActionResult Editar(string id)
        {
            var usuarioDb = _context.UserApp.FirstOrDefault(u => u.Id.Equals(id));
            if (usuarioDb is null)
            {
                return NotFound();
            }

            // Obtener los roles actuales del usuario:
            var rolUsuario = _context.UserRoles.ToList();
            var roles = _context.Roles.ToList();
            var rol = rolUsuario.FirstOrDefault(u => u.UserId == usuarioDb.Id);
            if (rol is not null)
            {
                usuarioDb.IdRol = roles.FirstOrDefault(u => u.Id == rol.RoleId)!.Id;
            }
            usuarioDb.ListaRoles = _context.Roles.Select(r => new SelectListItem
            {
                Text = r.Name,
                Value = r.Id
            });

            return View(usuarioDb);
        }

        [Authorize(Roles = "Administrador")]
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Editar(UserApp usuario)
        {
            if (ModelState.IsValid)
            {
                var usuarioDb = _context.UserApp.FirstOrDefault(u => u.Id.Equals(usuario.Id));
                if (usuarioDb is null)
                {
                    return NotFound();
                }

                var rolUsuario = _context.UserRoles.FirstOrDefault(u => u.UserId.Equals(usuarioDb.Id));
                if (rolUsuario is not null)
                {
                    // Obtener el rol actual:
                    var rolActual = _context.Roles.Where(u => u.Id.Equals(rolUsuario.RoleId)).Select(e => e.Name).FirstOrDefault();

                    // Eliminar el rol actual:
                    await _userManager.RemoveFromRoleAsync(usuarioDb, rolActual);
                }

                // Agregar usuario al nuevo rol seleccionado:
                await _userManager.AddToRoleAsync(usuarioDb, _context.Roles.FirstOrDefault(u => u.Id == usuario.IdRol)!.Name);
                _context.SaveChanges();

                return RedirectToAction(nameof(Index));
            }

            usuario.ListaRoles = _context.Roles.Select(r => new SelectListItem
            {
                Text = r.Name,
                Value = r.Id
            });

            return View(usuario);
        }

        // Metodo para bloquear/desbloquear usuarios:
        [Authorize(Roles = "Administrador")]
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult BloquearDesbloquear(string idUsuario)
        {
            var usuarioDb = _context.UserApp.FirstOrDefault(u => u.Id.Equals(idUsuario));
            if (usuarioDb is null)
            {
                return NotFound();
            }

            if (usuarioDb.LockoutEnd != null && usuarioDb.LockoutEnd > DateTime.Now)
            {
                // El usuario se encuentra bloqueado y lo podemos desbloquear:
                usuarioDb.LockoutEnd = DateTime.Now;
                TempData["Correcto"] = "Usuario desbloqueado correctamente";
            }
            else
            {
                // El usuario no esta bloqueado y lo podemos bloquear:
                usuarioDb.LockoutEnd = DateTime.Now.AddYears(100);
                TempData["Error"] = "Usuario bloqueado correctamente";
            }

            _context.SaveChanges();

            return RedirectToAction(nameof(Index));
        }

        // Metodo para borrar usuarios:
        [Authorize(Roles = "Administrador")]
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Borrar(string idUsuario)
        {
            var usuarioDb = _context.UserApp.FirstOrDefault(u => u.Id.Equals(idUsuario));
            if (usuarioDb is null)
            {
                return NotFound();
            }

            _context.UserApp.Remove(usuarioDb);

            _context.SaveChanges();

            TempData["Correcto"] = "Usuario borrado correctamente";
            return RedirectToAction(nameof(Index));
        }

        // Editar perfil:
        [HttpGet]
        public IActionResult EditarPerfil(string id)
        {
            if (id is null)
            {
                return NotFound();
            }

            var usuarioBd = _context.UserApp.Find(id);

            if (usuarioBd == null)
            {
                return NotFound();
            }

            return View(usuarioBd);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> EditarPerfil(UserApp userApp)
        {
            if (ModelState.IsValid)
            {
                var usuario = await _context.UserApp.FindAsync(userApp.Id);
                usuario!.Nombre = userApp.Nombre;
                usuario!.Url = userApp.Url;
                usuario!.CodigoPais = userApp.CodigoPais;
                usuario!.Telefono = userApp.Telefono;
                usuario!.Ciudad = userApp.Ciudad;
                usuario!.Pais = userApp.Pais;
                usuario!.Direccion = userApp.Direccion;
                usuario!.FechaNacimiento = userApp.FechaNacimiento;

                await _userManager.UpdateAsync(usuario);

                return RedirectToAction(nameof(Index), "Home");
            }

            return View(userApp);
        }

        // Cambiar contrasena (con usuario autenticado):
        [HttpGet]
        public IActionResult CambiarPassword(string? id)
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> CambiarPassword(CambiarPasswordViewModel cambiarPass, string email)
        {
            if (ModelState.IsValid)
            {
                var usuario = await _userManager.FindByEmailAsync(email);
                if (usuario == null)
                {
                    return RedirectToAction("Error");
                }

                var token = await _userManager.GeneratePasswordResetTokenAsync(usuario);
                
                var resultado = await _userManager.ResetPasswordAsync(usuario, token, cambiarPass.Password);
                if (resultado.Succeeded)
                {
                    return RedirectToAction("ConfirmacionCambioPassword");
                }
                else
                {
                    return View(cambiarPass);
                }
            }

            return View(cambiarPass);
        }

        [HttpGet]
        public IActionResult ConfirmacionCambioPassword()
        {
            return View();
        }

        // Manejo de claims:
        [HttpGet]
        public async Task<IActionResult> AdministrarClaimsUsuario(string idUsuario)
        {
            IdentityUser usuario = await _userManager.FindByIdAsync(idUsuario);
            if (usuario is null)
            {
                return NotFound();
            }

            var claimUsuarioActual = await _userManager.GetClaimsAsync(usuario);

            var modelo = new ClaimsUsuarioViewModel()
            {
                IdUsuario = idUsuario
            };

            foreach (Claim claim in ManejoClaims.ListaClaims)
            {
                ClaimUsuario claimUsuario = new ClaimUsuario
                {
                    TipoClaim = claim.Type
                };

                if (claimUsuarioActual.Any(c => c.Type == claim.Type))
                {
                    claimUsuario.Seleccionado = true;
                }

                modelo.Claims.Add(claimUsuario);
            }

            return View(modelo);
        }

        [HttpPost]
        public async Task<IActionResult> AdministrarClaimsUsuario(ClaimsUsuarioViewModel claimsUsuario)
        {
            IdentityUser usuario = await _userManager.FindByIdAsync(claimsUsuario.IdUsuario);
            if (usuario is null)
            {
                return NotFound();
            }

            var claims = await _userManager.GetClaimsAsync(usuario);
            var resultado = await _userManager.RemoveClaimsAsync(usuario, claims);

            if (!resultado.Succeeded)
            {
                return View(claimsUsuario);
            }

            resultado = await _userManager.AddClaimsAsync(
                usuario, claimsUsuario.Claims.Where(c => c.Seleccionado)

ProyectoIdentity/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ProyectoIdentity</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <!-- Iconos de bootstrap 5 -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.5/font/bootstrap-icons.css">

    <!-- Estilos para datepicker -->
    <link rel="stylesheet" href="//code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
    <link rel="stylesheet" href="//cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css" />

    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/ProyectoIdentity.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-dark bg-dark border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">ProyectoIdentity</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        
                        @if (User.IsInRole("Administrador"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="Usuarios" asp-action="Index">Admin. usuarios</a>
                            </li>

                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="Roles" asp-action="Index">Admin. roles</a>
                            </li>
                        }

                        <li class="nav-item">
                            <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>

                        <!-- Pruebas autorizacion (roles y claims) -->
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                                Acceso / Auth
                            </a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoPublico">Acceso público</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoAutenticado">Acceso autenticado</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoUsuario">Acceso usuario</a>
                                
                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoRegistrado">Acceso registrado</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoAdministrador">Acceso administrador</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoUsuarioAdministrador">Acceso usuario o administrador</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoUsuarioYAdministrador">Acceso usuario y administrador</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoAdministradorPermisoCrear">Acceso administrador con permiso para crear</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoAdministradorPermisoEditarBorrar">Acceso administrador con permisos de editar y borrar</a>

                                <a class="dropdown-item" asp-controller="Autorizacion" asp-action="AccesoAdministradorPermisoCrearEditarBorrar">Acceso administrador con permisos de crear, editar y borrar</a>
                            </ul>
                        </li>
                    </ul>

                    <!-- Vista parcial para acceso (login) y registro -->
                    <partial name="_LoginRegistroVistaParcial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - ProyectoIdentity - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    <script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>
    <script src="//cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>

    <script type="text/javascript">
        $(function() {
            $('#datepicker').datepicker({
                changeMonth: true,
                changeYear: true,
                yearRange: '1930:2020',
                dateFormat: 'yy-mm-dd'
            });
        });
    </script>

    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

ProyectoIdentity/Views/Shared/_LoginRegistroVistaParcial.cshtml
@using Microsoft.AspNetCore.Identity

@inject SignInManager<IdentityUser> SignInManager
@inject UserManager<IdentityUser> UserManager

<ul class="navbar-nav ml-auto">
    @if (SignInManager.IsSignedIn(User))
    {
        @if (User.IsInRole("Administrador"))
        {
            <li class="nav-item">
                <a class="nav-link text-white" asp-area="" asp-controller="Cuentas" asp-action="RegistroAdministrador"><strong>Tu rol es: Administrador ->> Registro Administrador</strong></a>
            </li>
        }
        else
        {
            <li>
                <p>Tu rol es: Registrado</p>
            </li>
        }

        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                Mi cuenta
            </a>
            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                <li class="nav-item">
                    <a class="nav-link text-dark" href="">Hola, @UserManager.GetUserName(User)</a>
                </li>

                <li class="nav-item">
                    <a class="nav-link text-dark" asp-area="" asp-controller="Usuarios" asp-action="EditarPerfil" asp-route-id="@UserManager.GetUserId(User)">Editar perfil</a>
                </li>

                <li><hr class="dropdown-divider"></li>
                
                <li class="nav-item">
                    <a class="nav-link text-dark" asp-area="" asp-controller="Usuarios" asp-action="CambiarPassword">Cambiar contraseña</a>
                </li>
            </ul>
        </li>

        

        <li class="nav-item">
            <form id="LogoutForm" method="POST" class="form-inline" asp-controller="Cuentas" asp-action="SalirAplicacion">
                <button type="submit" class="btn nav-link">Salir</button>
            </form>
        </li>
    }
    else
    {
        <li class="nav-item">
            <a class="nav-link text-white" asp-area="" asp-controller="Cuentas" asp-action="Registro">Registro</a>
        </li>

        <li class="nav-item">
            <a class="nav-link text-white" asp-area="" asp-controller="Cuentas" asp-action="Acceso">Acceder</a>
        </li>
    }
</ul>